/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM $SRCDIR/comm/mailnews/addrbook/public/nsILDAPURL.idl
 */

#ifndef __gen_nsILDAPURL_h__
#define __gen_nsILDAPURL_h__


#ifndef __gen_nsIURI_h__
#include "nsIURI.h"
#endif

#include "js/GCAnnotations.h"

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
#define NS_LDAPURL_CONTRACTID "@mozilla.org/network/ldap-url;1"

/* starting interface:    nsILDAPURL */
#define NS_ILDAPURL_IID_STR "8e3a6d33-2e68-40ba-8f94-6ac03f69066e"

#define NS_ILDAPURL_IID \
  {0x8e3a6d33, 0x2e68, 0x40ba, \
    { 0x8f, 0x94, 0x6a, 0xc0, 0x3f, 0x69, 0x06, 0x6e }}

class NS_NO_VTABLE nsILDAPURL : public nsIURI {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ILDAPURL_IID)

  /* Used by ToJSValue to check which scriptable interface is implemented. */
  using ScriptableInterfaceType = nsILDAPURL;

  /* void init (in unsigned long aUrlType, in long aDefaultPort, in AUTF8String aSpec, in string aOriginCharset, in nsIURI aBaseURI); */
  NS_IMETHOD Init(uint32_t aUrlType, int32_t aDefaultPort, const nsACString& aSpec, const char * aOriginCharset, nsIURI *aBaseURI) = 0;

  /* attribute AUTF8String dn; */
  NS_IMETHOD GetDn(nsACString& aDn) = 0;
  NS_IMETHOD SetDn(const nsACString& aDn) = 0;

  /* attribute ACString attributes; */
  NS_IMETHOD GetAttributes(nsACString& aAttributes) = 0;
  NS_IMETHOD SetAttributes(const nsACString& aAttributes) = 0;

  /* void addAttribute (in ACString aAttribute); */
  NS_IMETHOD AddAttribute(const nsACString& aAttribute) = 0;

  /* void removeAttribute (in ACString aAttribute); */
  NS_IMETHOD RemoveAttribute(const nsACString& aAttribute) = 0;

  /* boolean hasAttribute (in ACString aAttribute); */
  NS_IMETHOD HasAttribute(const nsACString& aAttribute, bool *_retval) = 0;

  /* attribute long scope; */
  NS_IMETHOD GetScope(int32_t *aScope) = 0;
  NS_IMETHOD SetScope(int32_t aScope) = 0;

  enum {
    SCOPE_BASE = 0,
    SCOPE_ONELEVEL = 1,
    SCOPE_SUBTREE = 2
  };

  /* attribute AUTF8String filter; */
  NS_IMETHOD GetFilter(nsACString& aFilter) = 0;
  NS_IMETHOD SetFilter(const nsACString& aFilter) = 0;

  /* attribute unsigned long options; */
  NS_IMETHOD GetOptions(uint32_t *aOptions) = 0;
  NS_IMETHOD SetOptions(uint32_t aOptions) = 0;

  enum {
    OPT_SECURE = 1U
  };

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsILDAPURL, NS_ILDAPURL_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSILDAPURL \
  NS_IMETHOD Init(uint32_t aUrlType, int32_t aDefaultPort, const nsACString& aSpec, const char * aOriginCharset, nsIURI *aBaseURI) override; \
  NS_IMETHOD GetDn(nsACString& aDn) override; \
  NS_IMETHOD SetDn(const nsACString& aDn) override; \
  NS_IMETHOD GetAttributes(nsACString& aAttributes) override; \
  NS_IMETHOD SetAttributes(const nsACString& aAttributes) override; \
  NS_IMETHOD AddAttribute(const nsACString& aAttribute) override; \
  NS_IMETHOD RemoveAttribute(const nsACString& aAttribute) override; \
  NS_IMETHOD HasAttribute(const nsACString& aAttribute, bool *_retval) override; \
  NS_IMETHOD GetScope(int32_t *aScope) override; \
  NS_IMETHOD SetScope(int32_t aScope) override; \
  NS_IMETHOD GetFilter(nsACString& aFilter) override; \
  NS_IMETHOD SetFilter(const nsACString& aFilter) override; \
  NS_IMETHOD GetOptions(uint32_t *aOptions) override; \
  NS_IMETHOD SetOptions(uint32_t aOptions) override; \

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSILDAPURL \
  nsresult Init(uint32_t aUrlType, int32_t aDefaultPort, const nsACString& aSpec, const char * aOriginCharset, nsIURI *aBaseURI); \
  nsresult GetDn(nsACString& aDn); \
  nsresult SetDn(const nsACString& aDn); \
  nsresult GetAttributes(nsACString& aAttributes); \
  nsresult SetAttributes(const nsACString& aAttributes); \
  nsresult AddAttribute(const nsACString& aAttribute); \
  nsresult RemoveAttribute(const nsACString& aAttribute); \
  nsresult HasAttribute(const nsACString& aAttribute, bool *_retval); \
  nsresult GetScope(int32_t *aScope); \
  nsresult SetScope(int32_t aScope); \
  nsresult GetFilter(nsACString& aFilter); \
  nsresult SetFilter(const nsACString& aFilter); \
  nsresult GetOptions(uint32_t *aOptions); \
  nsresult SetOptions(uint32_t aOptions); \

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSILDAPURL(_to) \
  NS_IMETHOD Init(uint32_t aUrlType, int32_t aDefaultPort, const nsACString& aSpec, const char * aOriginCharset, nsIURI *aBaseURI) override { return _to Init(aUrlType, aDefaultPort, aSpec, aOriginCharset, aBaseURI); } \
  NS_IMETHOD GetDn(nsACString& aDn) override { return _to GetDn(aDn); } \
  NS_IMETHOD SetDn(const nsACString& aDn) override { return _to SetDn(aDn); } \
  NS_IMETHOD GetAttributes(nsACString& aAttributes) override { return _to GetAttributes(aAttributes); } \
  NS_IMETHOD SetAttributes(const nsACString& aAttributes) override { return _to SetAttributes(aAttributes); } \
  NS_IMETHOD AddAttribute(const nsACString& aAttribute) override { return _to AddAttribute(aAttribute); } \
  NS_IMETHOD RemoveAttribute(const nsACString& aAttribute) override { return _to RemoveAttribute(aAttribute); } \
  NS_IMETHOD HasAttribute(const nsACString& aAttribute, bool *_retval) override { return _to HasAttribute(aAttribute, _retval); } \
  NS_IMETHOD GetScope(int32_t *aScope) override { return _to GetScope(aScope); } \
  NS_IMETHOD SetScope(int32_t aScope) override { return _to SetScope(aScope); } \
  NS_IMETHOD GetFilter(nsACString& aFilter) override { return _to GetFilter(aFilter); } \
  NS_IMETHOD SetFilter(const nsACString& aFilter) override { return _to SetFilter(aFilter); } \
  NS_IMETHOD GetOptions(uint32_t *aOptions) override { return _to GetOptions(aOptions); } \
  NS_IMETHOD SetOptions(uint32_t aOptions) override { return _to SetOptions(aOptions); } \

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSILDAPURL(_to) \
  NS_IMETHOD Init(uint32_t aUrlType, int32_t aDefaultPort, const nsACString& aSpec, const char * aOriginCharset, nsIURI *aBaseURI) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(aUrlType, aDefaultPort, aSpec, aOriginCharset, aBaseURI); } \
  NS_IMETHOD GetDn(nsACString& aDn) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDn(aDn); } \
  NS_IMETHOD SetDn(const nsACString& aDn) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetDn(aDn); } \
  NS_IMETHOD GetAttributes(nsACString& aAttributes) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAttributes(aAttributes); } \
  NS_IMETHOD SetAttributes(const nsACString& aAttributes) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetAttributes(aAttributes); } \
  NS_IMETHOD AddAttribute(const nsACString& aAttribute) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AddAttribute(aAttribute); } \
  NS_IMETHOD RemoveAttribute(const nsACString& aAttribute) override { return !_to ? NS_ERROR_NULL_POINTER : _to->RemoveAttribute(aAttribute); } \
  NS_IMETHOD HasAttribute(const nsACString& aAttribute, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->HasAttribute(aAttribute, _retval); } \
  NS_IMETHOD GetScope(int32_t *aScope) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetScope(aScope); } \
  NS_IMETHOD SetScope(int32_t aScope) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetScope(aScope); } \
  NS_IMETHOD GetFilter(nsACString& aFilter) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFilter(aFilter); } \
  NS_IMETHOD SetFilter(const nsACString& aFilter) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetFilter(aFilter); } \
  NS_IMETHOD GetOptions(uint32_t *aOptions) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOptions(aOptions); } \
  NS_IMETHOD SetOptions(uint32_t aOptions) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetOptions(aOptions); } \


/* starting interface:    nsILDAPURLParserResult */
#define NS_ILDAPURLPARSERRESULT_IID_STR "c0376fe9-2c7c-4f7b-a991-db9c3d95c1bb"

#define NS_ILDAPURLPARSERRESULT_IID \
  {0xc0376fe9, 0x2c7c, 0x4f7b, \
    { 0xa9, 0x91, 0xdb, 0x9c, 0x3d, 0x95, 0xc1, 0xbb }}

class NS_NO_VTABLE nsILDAPURLParserResult : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ILDAPURLPARSERRESULT_IID)

  /* Used by ToJSValue to check which scriptable interface is implemented. */
  using ScriptableInterfaceType = nsILDAPURLParserResult;

  /* readonly attribute AUTF8String host; */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD GetHost(nsACString& aHost) = 0;

  /* readonly attribute long port; */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD GetPort(int32_t *aPort) = 0;

  /* readonly attribute AUTF8String dn; */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD GetDn(nsACString& aDn) = 0;

  /* readonly attribute ACString attributes; */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD GetAttributes(nsACString& aAttributes) = 0;

  /* readonly attribute long scope; */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD GetScope(int32_t *aScope) = 0;

  /* readonly attribute AUTF8String filter; */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD GetFilter(nsACString& aFilter) = 0;

  /* readonly attribute unsigned long options; */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD GetOptions(uint32_t *aOptions) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsILDAPURLParserResult, NS_ILDAPURLPARSERRESULT_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSILDAPURLPARSERRESULT \
  NS_IMETHOD GetHost(nsACString& aHost) override; \
  NS_IMETHOD GetPort(int32_t *aPort) override; \
  NS_IMETHOD GetDn(nsACString& aDn) override; \
  NS_IMETHOD GetAttributes(nsACString& aAttributes) override; \
  NS_IMETHOD GetScope(int32_t *aScope) override; \
  NS_IMETHOD GetFilter(nsACString& aFilter) override; \
  NS_IMETHOD GetOptions(uint32_t *aOptions) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSILDAPURLPARSERRESULT \
  nsresult GetHost(nsACString& aHost); \
  nsresult GetPort(int32_t *aPort); \
  nsresult GetDn(nsACString& aDn); \
  nsresult GetAttributes(nsACString& aAttributes); \
  nsresult GetScope(int32_t *aScope); \
  nsresult GetFilter(nsACString& aFilter); \
  nsresult GetOptions(uint32_t *aOptions); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSILDAPURLPARSERRESULT(_to) \
  NS_IMETHOD GetHost(nsACString& aHost) override { return _to GetHost(aHost); } \
  NS_IMETHOD GetPort(int32_t *aPort) override { return _to GetPort(aPort); } \
  NS_IMETHOD GetDn(nsACString& aDn) override { return _to GetDn(aDn); } \
  NS_IMETHOD GetAttributes(nsACString& aAttributes) override { return _to GetAttributes(aAttributes); } \
  NS_IMETHOD GetScope(int32_t *aScope) override { return _to GetScope(aScope); } \
  NS_IMETHOD GetFilter(nsACString& aFilter) override { return _to GetFilter(aFilter); } \
  NS_IMETHOD GetOptions(uint32_t *aOptions) override { return _to GetOptions(aOptions); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSILDAPURLPARSERRESULT(_to) \
  NS_IMETHOD GetHost(nsACString& aHost) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHost(aHost); } \
  NS_IMETHOD GetPort(int32_t *aPort) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetPort(aPort); } \
  NS_IMETHOD GetDn(nsACString& aDn) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetDn(aDn); } \
  NS_IMETHOD GetAttributes(nsACString& aAttributes) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetAttributes(aAttributes); } \
  NS_IMETHOD GetScope(int32_t *aScope) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetScope(aScope); } \
  NS_IMETHOD GetFilter(nsACString& aFilter) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetFilter(aFilter); } \
  NS_IMETHOD GetOptions(uint32_t *aOptions) override { return !_to ? NS_ERROR_NULL_POINTER : _to->GetOptions(aOptions); } 


/* starting interface:    nsILDAPURLParser */
#define NS_ILDAPURLPARSER_IID_STR "340098c0-a881-49ab-a5e8-f79d04e6651c"

#define NS_ILDAPURLPARSER_IID \
  {0x340098c0, 0xa881, 0x49ab, \
    { 0xa5, 0xe8, 0xf7, 0x9d, 0x04, 0xe6, 0x65, 0x1c }}

class NS_NO_VTABLE nsILDAPURLParser : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ILDAPURLPARSER_IID)

  /* Used by ToJSValue to check which scriptable interface is implemented. */
  using ScriptableInterfaceType = nsILDAPURLParser;

  /* nsILDAPURLParserResult parse (in AUTF8String aSpec); */
  JS_HAZ_CAN_RUN_SCRIPT NS_IMETHOD Parse(const nsACString& aSpec, nsILDAPURLParserResult **_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsILDAPURLParser, NS_ILDAPURLPARSER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSILDAPURLPARSER \
  NS_IMETHOD Parse(const nsACString& aSpec, nsILDAPURLParserResult **_retval) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSILDAPURLPARSER \
  nsresult Parse(const nsACString& aSpec, nsILDAPURLParserResult **_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSILDAPURLPARSER(_to) \
  NS_IMETHOD Parse(const nsACString& aSpec, nsILDAPURLParserResult **_retval) override { return _to Parse(aSpec, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSILDAPURLPARSER(_to) \
  NS_IMETHOD Parse(const nsACString& aSpec, nsILDAPURLParserResult **_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Parse(aSpec, _retval); } 


#endif /* __gen_nsILDAPURL_h__ */
