/// AUTO GENERATED BY build.rs

use std::collections::HashMap;

use webrender_build::shader::ShaderVersion;

pub struct SourceWithDigest {
    pub source: &'static str,
    pub digest: &'static str,
}

pub struct OptimizedSourceWithDigest {
    pub vert_source: &'static str,
    pub frag_source: &'static str,
    pub digest: &'static str,
}

lazy_static! {
  pub static ref UNOPTIMIZED_SHADERS: HashMap<&'static str, SourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert("base", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/base.glsl"), digest: "d5ae695bab268b7d"});
    shaders.insert("blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/blend.glsl"), digest: "c24d37103d7732b9"});
    shaders.insert("brush", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/brush.glsl"), digest: "e5ee25c2d4aa738b"});
    shaders.insert("brush_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/brush_blend.glsl"), digest: "b6d41c3bcdd879fe"});
    shaders.insert("brush_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/brush_image.glsl"), digest: "78c6991c564706dd"});
    shaders.insert("brush_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/brush_linear_gradient.glsl"), digest: "54614a285d7f0d8f"});
    shaders.insert("brush_mix_blend", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/brush_mix_blend.glsl"), digest: "1e3c4c0da5cd8027"});
    shaders.insert("brush_opacity", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/brush_opacity.glsl"), digest: "23dc68b13e8ed560"});
    shaders.insert("brush_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/brush_solid.glsl"), digest: "5a694b6d94a13652"});
    shaders.insert("brush_yuv_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/brush_yuv_image.glsl"), digest: "a8b6658757295dce"});
    shaders.insert("clip_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/clip_shared.glsl"), digest: "86295c7240a0539"});
    shaders.insert("composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/composite.glsl"), digest: "7a91c1de1945ae26"});
    shaders.insert("cs_blur", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_blur.glsl"), digest: "2f62ec756238839a"});
    shaders.insert("cs_border_segment", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_border_segment.glsl"), digest: "1709acdfcd6a1cbf"});
    shaders.insert("cs_border_solid", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_border_solid.glsl"), digest: "980804c7958e43a7"});
    shaders.insert("cs_clip_box_shadow", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_clip_box_shadow.glsl"), digest: "56402cb95166d095"});
    shaders.insert("cs_clip_image", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_clip_image.glsl"), digest: "49451bdb6b91349e"});
    shaders.insert("cs_clip_rectangle", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_clip_rectangle.glsl"), digest: "250672b962675cbb"});
    shaders.insert("cs_conic_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_conic_gradient.glsl"), digest: "8fa1880a22365d8f"});
    shaders.insert("cs_fast_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_fast_linear_gradient.glsl"), digest: "e4b4c4cdd05aeb2d"});
    shaders.insert("cs_line_decoration", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_line_decoration.glsl"), digest: "9aadaa3f6bba4023"});
    shaders.insert("cs_linear_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_linear_gradient.glsl"), digest: "542367c87db5169"});
    shaders.insert("cs_radial_gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_radial_gradient.glsl"), digest: "81859f04d7aeef6f"});
    shaders.insert("cs_scale", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_scale.glsl"), digest: "211b392d8944e7"});
    shaders.insert("cs_svg_filter", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/cs_svg_filter.glsl"), digest: "274b22cdeaafbc82"});
    shaders.insert("debug_color", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/debug_color.glsl"), digest: "85a257c72a44c194"});
    shaders.insert("debug_font", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/debug_font.glsl"), digest: "70331ec5f9cec064"});
    shaders.insert("ellipse", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/ellipse.glsl"), digest: "1883f224293b6515"});
    shaders.insert("gpu_cache", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/gpu_cache.glsl"), digest: "e99b57d9cc26406a"});
    shaders.insert("gpu_cache_update", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/gpu_cache_update.glsl"), digest: "208078c3cbd97aa7"});
    shaders.insert("gradient", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/gradient.glsl"), digest: "8fd15af56b74882f"});
    shaders.insert("gradient_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/gradient_shared.glsl"), digest: "6f3fd5b68c496f08"});
    shaders.insert("prim_shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/prim_shared.glsl"), digest: "e7b0cd0b3e62ff6"});
    shaders.insert("ps_clear", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/ps_clear.glsl"), digest: "97422f9c0208e35e"});
    shaders.insert("ps_copy", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/ps_copy.glsl"), digest: "fee018569bc66328"});
    shaders.insert("ps_split_composite", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/ps_split_composite.glsl"), digest: "914caa19be5f6446"});
    shaders.insert("ps_text_run", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/ps_text_run.glsl"), digest: "e1fc282609affcda"});
    shaders.insert("rect", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/rect.glsl"), digest: "a072b75695c59cf6"});
    shaders.insert("render_task", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/render_task.glsl"), digest: "c4574b7a23485833"});
    shaders.insert("shared", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/shared.glsl"), digest: "df523dc077d5bcbf"});
    shaders.insert("shared_other", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/shared_other.glsl"), digest: "9f6298a27dfe79c6"});
    shaders.insert("transform", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/transform.glsl"), digest: "bf4f53677470b986"});
    shaders.insert("yuv", SourceWithDigest { source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/gfx/wr/webrender/res/yuv.glsl"), digest: "8abf49ff1bdef080"});
    shaders
  };

  pub static ref OPTIMIZED_SHADERS: HashMap<(ShaderVersion, &'static str), OptimizedSourceWithDigest> = {
    let mut shaders = HashMap::new();
    shaders.insert((ShaderVersion::Gl, "brush_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_blend_Gl.frag"),
        digest: "2a67a22d0dce73c0",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_blend_ALPHA_PASS_Gl.frag"),
        digest: "3d305e16151b491c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "699477a822a63514",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "abb416446305400c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "92f45d2e28f74a0c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "3ab312b94f1f1cb4",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "9b8ddaafc5db6f2e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "e45500ba92a45a9d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "776444f1bba1311e",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "9cc786d246426421",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "291e5724fd91a9a3",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "feb46e4c4d37d2",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_Gl.frag"),
        digest: "4748e20ffc0ba1f1",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "b291bdc5a3c08c4d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ALPHA_PASS_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ALPHA_PASS_TEXTURE_RECT_Gl.frag"),
        digest: "8e2ea3395e7b057c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "92ad6894bcc4163",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "81b7e7a3be997b6f",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_Gl.frag"),
        digest: "ac7f3f34f90802e9",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_Gl.frag"),
        digest: "cd9dde12f3fee812",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "3e6975854c2d8fb3",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_DEBUG_OVERDRAW_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_Gl.frag"),
        digest: "c06f43456936bc20",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_TEXTURE_2D_Gl.frag"),
        digest: "a80a3295b8c1dd42",
    });
    shaders.insert((ShaderVersion::Gl, "brush_image_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_image_TEXTURE_RECT_Gl.frag"),
        digest: "af5f5636434bae62",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_linear_gradient_Gl.frag"),
        digest: "ccfecb427519f472",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_linear_gradient_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_linear_gradient_ALPHA_PASS_Gl.frag"),
        digest: "4730c1deb17a04bf",
    });
    shaders.insert((ShaderVersion::Gl, "brush_linear_gradient_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_linear_gradient_DEBUG_OVERDRAW_Gl.frag"),
        digest: "2a001148bf4266b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_mix_blend_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_mix_blend_Gl.frag"),
        digest: "786d53293a37358b",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_mix_blend_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_mix_blend_ALPHA_PASS_Gl.frag"),
        digest: "f1096694fd997a22",
    });
    shaders.insert((ShaderVersion::Gl, "brush_mix_blend_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_mix_blend_DEBUG_OVERDRAW_Gl.frag"),
        digest: "e278878fa8b9e64f",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_Gl.frag"),
        digest: "c89f66ee78e79200",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_ALPHA_PASS_Gl.frag"),
        digest: "178490b1cf64dc9",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ALPHA_PASS_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_ALPHA_PASS_ANTIALIASING_Gl.frag"),
        digest: "1489df0a4429670d",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_ANTIALIASING_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_ANTIALIASING_Gl.frag"),
        digest: "2795e285192523c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_ANTIALIASING_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_Gl.frag"),
        digest: "6c94eca78186dd44",
    });
    shaders.insert((ShaderVersion::Gl, "brush_opacity_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_opacity_DEBUG_OVERDRAW_Gl.frag"),
        digest: "97f2077d57267e08",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_solid_Gl.frag"),
        digest: "934dd8e33d314528",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_ALPHA_PASS"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_solid_ALPHA_PASS_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_solid_ALPHA_PASS_Gl.frag"),
        digest: "147448b8b52841d6",
    });
    shaders.insert((ShaderVersion::Gl, "brush_solid_DEBUG_OVERDRAW"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_solid_DEBUG_OVERDRAW_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_solid_DEBUG_OVERDRAW_Gl.frag"),
        digest: "53ede36bf2e2cd4c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_Gl.frag"),
        digest: "b82ed584ab1f1531",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "38a3308a72674311",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_Gl.frag"),
        digest: "cd1615fd1741e99c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "2dc20938283ef02c",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_TEXTURE_2D_YUV_Gl.frag"),
        digest: "3cb074cf398040ae",
    });
    shaders.insert((ShaderVersion::Gl, "brush_yuv_image_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/brush_yuv_image_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "27773e77ba3ea4c3",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_FAST_PATH_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_FAST_PATH_TEXTURE_2D_Gl.frag"),
        digest: "2f10b4ba2ef63fa6",
    });
    shaders.insert((ShaderVersion::Gl, "composite_FAST_PATH_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_FAST_PATH_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_FAST_PATH_TEXTURE_RECT_Gl.frag"),
        digest: "181d9b7fb77535bf",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_TEXTURE_2D_Gl.frag"),
        digest: "6ecaddcc07ee2701",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_2D_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_TEXTURE_2D_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_TEXTURE_2D_YUV_Gl.frag"),
        digest: "377a8515e140e2b2",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_TEXTURE_RECT_Gl.frag"),
        digest: "42d4e2f17220d6a0",
    });
    shaders.insert((ShaderVersion::Gl, "composite_TEXTURE_RECT_YUV"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_TEXTURE_RECT_YUV_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/composite_TEXTURE_RECT_YUV_Gl.frag"),
        digest: "e8d6738ec90b1097",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_ALPHA_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_blur_ALPHA_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_blur_ALPHA_TARGET_Gl.frag"),
        digest: "e1ee6b18274ebea4",
    });
    shaders.insert((ShaderVersion::Gl, "cs_blur_COLOR_TARGET"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_blur_COLOR_TARGET_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_blur_COLOR_TARGET_Gl.frag"),
        digest: "44b296e917f5ffe0",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_segment"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_border_segment_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_border_segment_Gl.frag"),
        digest: "8495134f5ed37bf5",
    });
    shaders.insert((ShaderVersion::Gl, "cs_border_solid"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_border_solid_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_border_solid_Gl.frag"),
        digest: "9fd688a8c266d2da",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_box_shadow_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_clip_box_shadow_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_clip_box_shadow_TEXTURE_2D_Gl.frag"),
        digest: "27ebd9a8598b86dd",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_image_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_clip_image_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_clip_image_TEXTURE_2D_Gl.frag"),
        digest: "cc3eb79ed945df7e",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_clip_rectangle_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_clip_rectangle_Gl.frag"),
        digest: "2c8a1dff0fe0a10f",
    });
    shaders.insert((ShaderVersion::Gl, "cs_clip_rectangle_FAST_PATH"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_clip_rectangle_FAST_PATH_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_clip_rectangle_FAST_PATH_Gl.frag"),
        digest: "f2f1ca9e786e5c25",
    });
    shaders.insert((ShaderVersion::Gl, "cs_conic_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_conic_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_conic_gradient_Gl.frag"),
        digest: "b7cda5b4a185979c",
    });
    shaders.insert((ShaderVersion::Gl, "cs_fast_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_fast_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_fast_linear_gradient_Gl.frag"),
        digest: "3d4ec20a2b40f905",
    });
    shaders.insert((ShaderVersion::Gl, "cs_line_decoration"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_line_decoration_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_line_decoration_Gl.frag"),
        digest: "7943c68da0973c69",
    });
    shaders.insert((ShaderVersion::Gl, "cs_linear_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_linear_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_linear_gradient_Gl.frag"),
        digest: "d472e0930d426d9d",
    });
    shaders.insert((ShaderVersion::Gl, "cs_radial_gradient"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_radial_gradient_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_radial_gradient_Gl.frag"),
        digest: "da73355e0977ab65",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_scale_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_scale_TEXTURE_2D_Gl.frag"),
        digest: "8b96616ecbcd584b",
    });
    shaders.insert((ShaderVersion::Gl, "cs_scale_TEXTURE_RECT"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_scale_TEXTURE_RECT_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_scale_TEXTURE_RECT_Gl.frag"),
        digest: "d131714d8283049d",
    });
    shaders.insert((ShaderVersion::Gl, "cs_svg_filter"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_svg_filter_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/cs_svg_filter_Gl.frag"),
        digest: "aca9420acaec4776",
    });
    shaders.insert((ShaderVersion::Gl, "debug_color"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/debug_color_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/debug_color_Gl.frag"),
        digest: "f458fe7ea40bd77e",
    });
    shaders.insert((ShaderVersion::Gl, "debug_font"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/debug_font_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/debug_font_Gl.frag"),
        digest: "503ec56c19b6bd2c",
    });
    shaders.insert((ShaderVersion::Gl, "ps_clear"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_clear_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_clear_Gl.frag"),
        digest: "9ef2acc3bbd621e8",
    });
    shaders.insert((ShaderVersion::Gl, "ps_copy"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_copy_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_copy_Gl.frag"),
        digest: "514726576460ee72",
    });
    shaders.insert((ShaderVersion::Gl, "ps_split_composite"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_split_composite_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_split_composite_Gl.frag"),
        digest: "9567385257869ee1",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "4206a389e17781d0",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "f7f64128b28324e6",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_Gl.frag"),
        digest: "38b0cb66281e545a",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_ALPHA_PASS_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_ALPHA_PASS_TEXTURE_2D_Gl.frag"),
        digest: "f09e4a2ad5873fba",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_Gl.frag"),
        digest: "4b8cfd14ebbc7b1e",
    });
    shaders.insert((ShaderVersion::Gl, "ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D"), OptimizedSourceWithDigest {
        vert_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.vert"),
        frag_source: include_str!("/builddir/build/BUILD/thunderbird-102.14.0/objdir/powerpc64le-unknown-linux-gnu/release/build/webrender-fffd283fd7e28d1d/out/ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_Gl.frag"),
        digest: "eed566e8b1b1330d",
    });
    shaders
  };
}
